﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'Example version 1.00
Sub Class_Globals
	Private xui As XUI
	Private ImageView1 As B4XView
	Private OriginalBmp() As B4XBitmap
	Private bc1 As BitmapCreator
	Private OriginalBC As BitmapCreator
	Private ImageIndex As Int
	Private MouseBitmapCreator As BitmapCreator
	Private LastXORedRect As B4XRect
	Private scale As Float = 1
	Private CLV1 As CustomListView
	Private Panel1 As B4XView 'ignore
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	Dim Width, Height As Int
#if B4J
	Width = 600
	Height = 400
	Dim iv As ImageView = ImageView1
	Dim fx As JFX
	iv.MouseCursor = fx.Cursors.NONE
	'add MouseExit event to the ImageView
	Dim jo As JavaObject = iv
	jo.RunMethod("setOnMouseExited", Array(jo.CreateEventFromUI("javafx.event.EventHandler", "MouseExit", True)))
#else if B4A
	scale = GetDeviceLayoutValues.Scale
	Width = 100%x / scale
	Height = 280
#else if B4i
	Width = GetDeviceLayoutValues.Width
	Height = 280
#end if
	OriginalBmp = Array As B4XBitmap ( _
		xui.LoadBitmapResize(File.DirAssets, "bas-van-brandwijk-588535-unsplash.jpg", Width, Height, False), _
		xui.LoadBitmapResize(File.DirAssets, "blossom-flora-flowers-94015.jpg", Width, Height, False), _
		xui.LoadBitmapResize(File.DirAssets, "berry-delicious-dessert-70861.jpg", Width, Height, False) _
	)
	PrepareMouseEffect
	bc1.Initialize(Width, Height)
	CLV1.DefaultTextBackgroundColor = 0xFF484545
	CLV1.DefaultTextColor = xui.Color_White
	CLV1.AddTextItem("Change Image", "Change_Image")
	CLV1.AddTextItem("Simple Drawing", "SimpleDrawing_Example")
	CLV1.AddTextItem("Pixelate Animation", "MultiPixelate_Example")
	CLV1.AddTextItem("Color Bins", "BinImage_Example")
	CLV1.AddTextItem("Blur", "Blur_Example")
	CLV1.AddTextItem("GreyScale", "GreyScale_Example")
	CLV1.AddTextItem("Negate", "Negate_Example")
	CLV1.AddTextItem("More Light", "Light_Example")
	CLV1.AddTextItem("Less Light", "Dark_Example")
	CLV1.AddTextItem("Curve Drawing", "DrawCurved_Example")
	Change_Image
End Sub

Private Sub PrepareMouseEffect
	MouseBitmapCreator.Initialize(80, 80)
	'The MouseBitmapCreator image is used as a mask. 
	Dim cvs As B4XCanvas = CreateCanvas(MouseBitmapCreator.mWidth, MouseBitmapCreator.mHeight)
	cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, 25, xui.Color_Red, True, 0)
	Dim offset As Int = 15
	If xui.IsB4i Then offset = 20
	cvs.DrawText("B4X", cvs.TargetRect.Width / 2, offset, xui.CreateDefaultBoldFont(20 / scale), xui.Color_Red, "CENTER")
	cvs.Invalidate
	MouseBitmapCreator.CopyPixelsFromBitmap(cvs.CreateBitmap)
	cvs.Release
	LastXORedRect.Initialize(0, 0, 0, 0)
End Sub

Public Sub ResizeEvent (width As Int, height As Int)
	Dim iw As Int = bc1.mWidth * scale
	Dim ih As Int = bc1.mHeight * scale
	ImageView1.SetLayoutAnimated(0, width / 2 - iw / 2, 0, iw, ih)
	If Panel1.IsInitialized Then Panel1.SetLayoutAnimated(0, ImageView1.Left, ImageView1.Top, ImageView1.Width, ImageView1.Height)
End Sub


Sub CLV1_ItemClick (Index As Int, Value As Object)
	CallSub(Me, Value)
	Update
End Sub

Sub Change_Image
	ImageIndex = (ImageIndex + 1) Mod OriginalBmp.Length
	Dim bmp As B4XBitmap = OriginalBmp(ImageIndex)
	OriginalBC.Initialize(bmp.Width, bmp.Height)
	OriginalBC.CopyPixelsFromBitmap(bmp)
	ResizeEvent(ImageView1.Parent.Width, ImageView1.Parent.Height)
	LastXORedRect.Width = 0
	If Rnd(0, 2) = 1 Then
		RadarAnimation
	Else
		RandomBlocks
	End If
End Sub

Sub Update
	ImageView1.SetBitmap(bc1.Bitmap)
End Sub

#if B4A or B4i
Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	Dim cx As Int = X / scale
	Dim cy As Int = Y / scale - 50
	
#else if B4J
Sub MouseExit_Event (MethodName As String, Args() As Object) As Object
	If LastXORedRect.Width > 0 Then
		NegateBasedOnBC(LastXORedRect)
		LastXORedRect.Width = 0
		Update	
	End If
	Return True
End Sub

Sub ImageView1_MouseMoved (EventData As MouseEvent)
	Dim cx As Int = EventData.X
	Dim cy As Int = EventData.Y
	Dim Action As Int = 0
#end if
	Dim target As B4XRect
	target.Initialize(cx - MouseBitmapCreator.mWidth / 2, cy - MouseBitmapCreator.mHeight / 2, cx + MouseBitmapCreator.mWidth / 2, cy + MouseBitmapCreator.mHeight / 2)
	If LastXORedRect.Width > 0 Then
		NegateBasedOnBC(LastXORedRect)
	End If
	If Action = 1 Then
		LastXORedRect.Width = 0
	Else
		NegateBasedOnBC(target)
		LastXORedRect = target
	End If
	Update
End Sub

Private Sub NegateBasedOnBC (Target As B4XRect)
	Dim argb As ARGBColor
	For x = Max(0, Target.Left) To Min(bc1.mWidth - 1, Target.Right - 1)
		For y = Max(0, Target.Top) To Min(bc1.mHeight - 1, Target.Bottom - 1)
			If MouseBitmapCreator.IsTransparent(x - Target.Left, y - Target.Top) Then Continue
			bc1.GetARGB(x, y, argb)
			argb.r = Bit.Xor(argb.r, 0xff)
			argb.g = Bit.Xor(argb.g, 0xff)
			argb.b = Bit.Xor(argb.b, 0xff)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub SimpleDrawing_Example
	Dim bmp As B4XBitmap = CreateBitmapWithText("Testing 1, 2, 3...")
	Dim target As B4XRect
	target.Initialize(10, 80, 10 + bmp.Width, 80 + bmp.Height) 'ignore
	bc1.DrawBitmap(bmp, target)
End Sub


Sub DrawCurved_Example
	Dim bmp As B4XBitmap = CreateBitmapWithText("Testing 1, 2, 3...")
	DrawCurvedBitmap(bmp, 200, 200, 220, 320, 180)
	ImageView1.SetBitmap(bc1.Bitmap)
End Sub

Sub DrawCurvedBitmap (bmp As B4XBitmap, TargetX As Int, TargetY As Int, _
		 StartAngle As Float, EndAngle As Float, Radius As Float)
	Dim temp As BitmapCreator
	temp.Initialize(bmp.Width, bmp.Height)
	temp.CopyPixelsFromBitmap(bmp)
	Dim DeltaAngle As Float = EndAngle - StartAngle
	Dim pm As PremultipliedColor
	Dim x, y As Float
	For x = 0 To temp.mWidth - 1 Step 0.5
		Dim alpha As Float = x / temp.mWidth * DeltaAngle + StartAngle
		Dim CosL As Float = CosD(alpha)
		Dim SinL As Float = SinD(alpha)
		Dim ox As Float = TargetX + CosL * Radius
		Dim oy As Float = TargetY + SinL * Radius
		For y = 0 To temp.mHeight - 1 Step 0.5
			bc1.BlendPixel(ox, oy, temp.GetPremultipliedColor(x, y, pm))
			ox = ox - CosL / 2
			oy = oy - SinL / 2
		Next
	Next
End Sub

Sub CreateBitmapWithText (text As String) As B4XBitmap
	Dim cvs As B4XCanvas = CreateCanvas(300, 40)
	'cvs.DrawRect(cvs.TargetRect, xui.Color_Magenta, True, 0)
	Dim offset As Int = 10
	If xui.IsB4i Then offset = 18
	cvs.DrawText(text, 0, cvs.TargetRect.Height / 2 + offset, xui.CreateDefaultBoldFont(40 / scale), xui.Color_White, "LEFT")
	cvs.Invalidate
	Dim bmp As B4XBitmap = cvs.CreateBitmap
	cvs.Release
	Return bmp
End Sub

Private Sub CreateCanvas(width As Int, height As Int) As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, width, height)
	Dim cvs As B4XCanvas
	cvs.Initialize(p)
	Return cvs
End Sub


Private Sub RadarAnimation
	Dim delta As Int
	If xui.IsB4J Then delta = 5 Else delta = 10
	Dim cx As Int = bc1.mWidth / 2
	Dim cy As Int = bc1.mHeight / 2
	
	Dim From As Int
	Dim Sign As Int
	Private pm As PremultipliedColor
	For i = -3 To 0
		Select (i + 4) Mod 4
			Case 0
				Sign = 1
				From = -90
			Case 1
				Sign = 1
				From = 0
			Case 2
				Sign = -1
				From = -90
			Case 3
				Sign = -1
				From = 0
		End Select
		For StartAngle = From To From + 90 - delta Step delta
			For y = 0 To cy
				Dim FirstPointX As Int = cx + Sign * (y + 0.0001) * TanD(StartAngle)
				Dim LastPointX As Int = cx + Sign * (y + 0.0001) * TanD(StartAngle+delta)
				For x = Max(0, Min(FirstPointX, LastPointX)) To Min(bc1.mWidth - 1, Max(FirstPointX, LastPointX))
					Dim yy As Int = Max(0, Min(cy + Sign * y, bc1.mHeight - 1))
					bc1.SetPremultipliedColor(x, yy, OriginalBC.GetPremultipliedColor(x, yy, pm))
				Next
			Next
			ImageView1.SetBitmap(bc1.Bitmap)
			#if not (debug)
			'Resumable subs in debug mode are too slow for process intensive code.
			'Run in release mode to see effect.
			Sleep(1)
			#end if
		Next
	Next
End Sub

Private Sub RandomBlocks
	Dim BlockSize As Int
	If xui.IsB4J Then BlockSize = 20 Else BlockSize = 40
#if DEBUG
	BlockSize = 200
	Log("Run in release mode!!!")
#End If
	Dim RowCount As Int = (OriginalBC.mWidth / BlockSize + 1)
	Dim count As Int = RowCount * (OriginalBC.mHeight / BlockSize + 1)
	Dim rect As B4XRect
	rect.Initialize(0, 0, 0, 0)
	Dim arr(count) As Int
	For i = 0 To count - 1
		arr(i) = i
	Next
	ShuffleArray(arr)
	For i = 0 To count - 1
		Dim vblock As Int = arr(i)
		Dim column As Int = vblock Mod RowCount
		Dim row As Int = vblock / RowCount
		rect.Left = column * BlockSize
		rect.Width = BlockSize
		rect.Top = row * BlockSize
		rect.Height = BlockSize
		bc1.DrawBitmapCreator(OriginalBC, rect, rect.Left, rect.Top)
		ImageView1.SetBitmap(bc1.Bitmap)
		Sleep(0)
	Next
	
End Sub

Private Sub BinImage_Example
	Dim BinSize As Int = 50
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Floor(argb.r / BinSize) * BinSize
			argb.g = Floor(argb.g / BinSize) * BinSize
			argb.b = Floor(argb.b / BinSize) * BinSize
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub


Private Sub Blur_Example
'	Dim BlurFilter() As Float = Array As Float( _
'		0.0625, 0.125, 0.0625, _
'		0.125, 0.25, 0.125, _
'		0.0625, 0.125, 0.0625 _
'		)
'	ConvolutionFilter3x3(bc1, BlurFilter)
	
	Dim argb As ARGBColor
	Dim sum As ARGBColor
	sum.a = 255
	For x = 1 To bc1.mWidth - 2
		For y = 1 To bc1.mHeight - 2
			sum.r = 0
			sum.g = 0
			sum.b = 0
			For mx = -1 To 1
				For my = -1 To 1
					bc1.GetARGB(x + mx, y + my, argb)
					sum.r = sum.r + argb.r * 0.11
					sum.g = sum.g + argb.g * 0.11
					sum.b = sum.b + argb.b * 0.11
				Next
			Next
			bc1.SetARGB(x, y, sum)
		Next
	Next
End Sub



Sub GreyScale_Example
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			Dim c As Int = argb.r * 0.21 + argb.g * 0.72 + 0.07 * argb.b
			argb.r = c
			argb.g = c
			argb.b = c
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub Negate_Example
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Bit.Xor(argb.r, 0xff)
			argb.g = Bit.Xor(argb.g, 0xff)
			argb.b = Bit.Xor(argb.b, 0xff)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub Light_Example
	Brightness(1.1)
End Sub

Sub Dark_Example
	Brightness(0.9)
End Sub

Sub Brightness(Factor As Float)
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Min(255, argb.r * Factor)
			argb.g = Min(255, argb.g * Factor)
			argb.b = Min(255, argb.b * Factor)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Private Sub MultiPixelate_Example
	For i = 21 To 1 Step -2
		If i > 1 Then
			Pixelate(OriginalBC, bc1, i, i)
		Else
			bc1.DrawBitmapCreator(OriginalBC, OriginalBC.TargetRect, 0, 0)
		End If
		ImageView1.SetBitmap(bc1.Bitmap)
		Sleep(100)
	Next
End Sub

Sub Pixelate (bcOriginal As BitmapCreator, bcTarget As BitmapCreator, BoxWidth As Int, BoxHeight As Int)
	Dim rect As B4XRect
	rect.Initialize(0, 0, 0, 0)
	For x = 0 To bcOriginal.mWidth - 1 Step BoxWidth
		rect.Left = x
		rect.Right = x + BoxWidth - 1
		For y = 0 To bcOriginal.mHeight - 1 Step BoxHeight
			rect.Top = y
			rect.Bottom = y + BoxHeight - 1
			bcTarget.FillRect(rect, bcOriginal.GetColor(Min(bcOriginal.mWidth - 1, x + BoxWidth / 2), Min(bcOriginal.mHeight - 1, y + BoxHeight / 2)))
		Next
	Next
End Sub

Public Sub ConvolutionFilter3x3 (bc As BitmapCreator, Matrix() As Float)
	Dim argb As ARGBColor
	Dim sum As ARGBColor
	sum.a = 255
	For x = 1 To bc.mWidth - 2
		For y = 1 To bc.mHeight - 2
			sum.r = 0
			sum.g = 0
			sum.b = 0
			For mx = -1 To 1
				For my = -1 To 1
					Dim m As Float = Matrix((mx + 1) + (my + 1) * 3)
					If m = 0 Then Continue
					bc.GetARGB(x + mx, y + my, argb)
					sum.r = sum.r + argb.r * m
					sum.g = sum.g + argb.g * m
					sum.b = sum.b + argb.b * m
				Next
			Next
			sum.r = Min(255, Abs(sum.r))
			sum.g = Min(255, Abs(sum.g))
			sum.b = Min(255, Abs(sum.b))
			bc.SetARGB(x, y, sum)
		Next
	Next
End Sub

Private Sub ShuffleArray (arr() As Int)
	For i = arr.Length - 1 To 1 Step -1
		Dim j As Int = Rnd(0, i + 1)
		Dim c As Int = arr(i)
		arr(i) = arr(j)
		arr(j) = c
	Next
End Sub



